﻿// 圖像觀看器，版本2。
// Colin Moock著作、碁峯資訊股份有限公司出版發行之《精通ActionScript 2.0》書籍範例。

class ImageViewer {
  // 影片片段參考
  private var container_mc:MovieClip;
  private var target_mc:MovieClip;

  // 影片片段深度
  private var containerDepth:Number;  
  private static var imageDepth:Number = 0;
  private static var maskDepth:Number = 1;
  private static var borderDepth:Number = 2;

  // 邊框樣式
  private var borderThickness:Number;
  private var borderColor:Number;

  // 建構函數
  public function ImageViewer (target:MovieClip, 
                               depth:Number, 
                               x:Number, 
                               y:Number, 
                               w:Number, 
                               h:Number,
                               borderThickness:Number,
                               borderColor:Number) {
    // 指派屬性值
    target_mc = target;
    containerDepth = depth;
    this.borderThickness = borderThickness;
    this.borderColor = borderColor;

     // 替此ImageViewer設定視覺資產
    buildViewer(x, y, w, h);
  }

  // 建立擺放影像、遮罩和邊框的影片片段。
  // 這個方法將適用於每個建立片段的方法。 
  private function buildViewer (x:Number, 
                                y:Number, 
                                w:Number, 
                                h:Number):Void {
      createMainContainer(x, y);
      createImageClip();
      createImageClipMask(w, h);
      createBorder(w, h);
  }

   // 建立擺放所有資產的容器 
  private function createMainContainer (x:Number, y:Number):Void {
    container_mc = 
      target_mc.createEmptyMovieClip("container_mc" + containerDepth, 
                                     containerDepth);
    // 設定容器片段的位置
    container_mc._x = x;
    container_mc._y = y;
  }

   // 建立放置載入影像的影片片段 
  private function createImageClip ():Void {
    container_mc.createEmptyMovieClip("image_mc", imageDepth);
  }

   // 建立擺在影像上的遮色片  
  private function createImageClipMask (w:Number,
                                        h:Number):Void {
    // 只有指定了有效的寬度和高度值時，才建立遮色片。
    if (!(w > 0 && h > 0)) {
      return;
    }

    // 在容器片段中，建立放在影像上面的遮色片的片段。
    container_mc.createEmptyMovieClip("mask_mc", maskDepth);

    // 在遮罩中繪製一個矩形。
    container_mc.mask_mc.moveTo(0, 0);
    container_mc.mask_mc.beginFill(0x0000FF);  // 為了方便除錯所以用藍色 
    container_mc.mask_mc.lineTo(w, 0);
    container_mc.mask_mc.lineTo(w, h);
    container_mc.mask_mc.lineTo(0, h);
    container_mc.mask_mc.lineTo(0, 0);
    container_mc.mask_mc.endFill();
  
    // 隱藏遮罩（即使看不見，它仍具有遮色片的功用）。
	// 若要在除錯階段觀看此遮罩，請將底下這行程式改成註解。
    container_mc.mask_mc._visible = false; 

    // 請注意，我們尚未應用遮色片。我們必須在
	// 開始載入影像之後才可以應用遮罩，否則載
	// 入的影像將會移除遮罩。 
  }

  // 建立圍繞影像的邊框  
  private function createBorder (w:Number,
                                 h:Number):Void {
    // 只有指定了有效的寬度和高度值時，才能建立邊框。
    if (!(w > 0 && h > 0)) {
      return;
    }

    // 在容器片段中，建立包含邊框片段的影片片段。
    container_mc.createEmptyMovieClip("border_mc", borderDepth);
  
    // 在邊框片段裡面繪製一個指定大小和顏色的矩形邊框。 
    container_mc.border_mc.lineStyle(borderThickness, borderColor);
    container_mc.border_mc.moveTo(0, 0);
    container_mc.border_mc.lineTo(w, 0);
    container_mc.border_mc.lineTo(w, h);
    container_mc.border_mc.lineTo(0, h);
    container_mc.border_mc.lineTo(0, 0);
  }

// 載入指定影像
public function loadImage (URL:String):Void {
	// 將JPEG檔載入image_mc片段 
	container_mc.image_mc.loadMovie(URL);
	
	// 底下是不好的寫法。我們將在範例5-6的版本3中，
	// 加入適當的等待載入程式。
	// 過了這個影格之後，將開始載入影像檔，這時，
	// 程式將能安全地在image_mc片段中套用遮色片。 
    container_mc.onEnterFrame = function ():Void {
      this.image_mc.setMask(this.mask_mc);
      delete this.onEnterFrame;
    }
  }
}